DECLARE SUB draw.menu ()
DEFINT A-Z

'=================================declarations
DECLARE SUB handle.option (option$)
DECLARE FUNCTION are.you.sure% ()
DECLARE FUNCTION buttonpressed% ()
DECLARE FUNCTION current.menu% ()
DECLARE FUNCTION mousex% ()
DECLARE FUNCTION mousey% ()
DECLARE FUNCTION okay% (a$)
DECLARE FUNCTION on.a.menu% ()
DECLARE FUNCTION read.menu$ ()
DECLARE SUB close.a.menu ()
DECLARE SUB drawscreen ()
DECLARE SUB load.menus (filenum%)
DECLARE SUB open.a.menu (menu.index%)
DECLARE SUB showmouse ()
'=================================interrupts
'ON ERROR GOTO errhandle

'=================================variables
CONST xtextsize = 8
CONST ytextsize = 16

TYPE regtype
    ax AS INTEGER: bx AS INTEGER
    cx AS INTEGER: dx AS INTEGER
    bp AS INTEGER: si AS INTEGER
    di AS INTEGER: flags AS INTEGER
    ds AS INTEGER: es AS INTEGER
END TYPE
DIM SHARED inregs AS regtype, outregs AS regtype, menus, background(10000)
DIM SHARED old.menu.index, minmenx, minmeny, maxmenx, maxmeny, done, name$
DIM SHARED rusure(5000), menu.open, oldmousex, oldmousey, maximum.menux
DIM SHARED colour, drawmode
colour = 15
drawmode = 1
'=========================Misc.
'------------initialize mouse
inregs.ax = 0: CALL interrupt(51, inregs, outregs)
inregs.ax = 4: CALL interrupt(51, inregs, outregs)
inregs.ax = 3: CALL interrupt(51, inregs, outregs)

'------------load menus
OPEN "scribble.mnu" FOR INPUT AS #1
INPUT #1, menus
DIM SHARED menu$(menus, 20), menumax(menus), menulength(menus)
load.menus (1)
CLOSE #1

'------------set up screen
SCREEN 12: CLS
PALETTE 0, 63 + 256 * 63 + 65536 * 63
PALETTE 15, 0
drawscreen
showmouse

'===============================main program==================================
DO
    '======================== left button pressed
    IF buttonpressed THEN
        IF mousey <= 15 AND mousex <= maximum.menux THEN
            oldx = -1
            oldy = -1
            '------- left button on the upper menus
            IF menu.open <> 0 THEN
                close.a.menu
            END IF
            IF menu.open <> current.menu THEN
                menu.open = current.menu
                showmouse
                open.a.menu (current.menu)
                showmouse
            END IF
            DO: LOOP UNTIL buttonpressed = 0
        ELSEIF on.a.menu AND menu.open <> 0 THEN
            handle.option (read.menu$)'----read.menu$ is a function
        ELSE
            '------- button pressed off the menus
            IF menu.open <> 0 THEN
                close.a.menu
                DO: LOOP UNTIL buttonpressed = 0
            ELSE ' (all menus are closed)
                IF oldx <> -1 THEN
                    '====draw here
                    x = mousex
                    y = mousey
                    IF buttonpressed = 1 THEN
                        showmouse
                        IF drawmode = 1 THEN
                            LINE (oldx, oldy)-(x, y), colour
                            oldx = x
                            oldy = y
                        ELSEIF drawmode = 0 THEN
                            a = x - 10
                            B = y - 10
                            c = x + 10
                            d = y + 10
                            LINE (a, B)-(c, d), 0, BF
                            IF a < maximum.menux AND B < ytextsize THEN draw.menu
                        END IF
                        showmouse
                    ELSEIF buttonpressed = 2 THEN
                    END IF
                ELSE
                    oldx = mousex
                    oldy = mousey
                END IF
            END IF
        END IF
    ELSE
        oldx = -1
    END IF
LOOP UNTIL done
END
'===============================subroutines===================================

'errhandle:
'    STOP
'    RESUME NEXT

FUNCTION are.you.sure
    showmouse
    GET (239, 218)-(375, 293), rusure
    PUT (239, 218), rusure
    LOCATE 15, 33: PRINT "Are you sure?";
    LOCATE 17, 34: PRINT " Yes    No "
  
    '-------box yes
    LINE (271, 256)-(296, 272), , B
    LINE (269, 254)-(298, 274), , B
    LINE (270, 273)-(297, 273)
    LINE (297, 273)-(297, 255)
    '-------box no
    LINE (322, 256)-(347, 272), , B
    LINE (320, 254)-(349, 274), , B
    LINE (321, 273)-(348, 273)
    LINE (348, 273)-(348, 255)
    '-------box question
    LINE (239, 218)-(375, 293), , B
    LINE (241, 220)-(373, 291), , B
    LINE (240, 292)-(374, 292)
    LINE (374, 292)-(374, 219)
    showmouse
  
    DO
        a$ = LCASE$(INKEY$)
        IF buttonpressed THEN
            c = 1
            x = mousex
            y = mousey
        END IF
        IF c = 1 AND y > 254 AND y < 272 THEN
            IF x > 271 AND x < 298 THEN
                a$ = "y"
                y1 = 255: x1 = 270: x2 = 297: y2 = 273
                showmouse
                LINE (x2, y2)-(x2, y1), 0
                LINE (x2, y2)-(x1, y2), 0
                LINE (x1, y1)-(x1, y2)
                LINE (x1, y1)-(x2, y1)
                showmouse
                DO
                LOOP UNTIL buttonpressed = 0
            ELSEIF x > 320 AND x < 349 THEN
                a$ = "n"
                y1 = 255: x1 = 321: x2 = 348: y2 = 273
                showmouse
                LINE (x2, y2)-(x2, y1), 0
                LINE (x2, y2)-(x1, y2), 0
                LINE (x1, y1)-(x1, y2)
                LINE (x1, y1)-(x2, y1)
                showmouse
                DO
                LOOP UNTIL buttonpressed = 0
            ELSE
                c = 0
            END IF
        ELSEIF c = 1 THEN
            c = 0
        END IF
    LOOP UNTIL a$ = "y" OR a$ = "n"
    showmouse
    PUT (239, 218), rusure, PSET
    showmouse
    are.you.sure = ABS(a$ = "y")
END FUNCTION

FUNCTION buttonpressed%
    inregs.ax = 3: CALL interrupt(51, inregs, outregs)
    buttonpressed = outregs.bx
END FUNCTION

SUB close.a.menu '(menu.index)
    showmouse
    'PUT (xtextsize * menumax(old.menu.index - 1), ytextsize), background, PSET
    PUT (minmenx, minmeny), background, PSET
    showmouse
    menu.open = 0
END SUB

FUNCTION current.menu
    FOR n = 1 TO menus
        IF mousex < menumax(n) * xtextsize THEN EXIT FOR
    NEXT n
    IF n > menus THEN n = menus
    current.menu = n
END FUNCTION

SUB draw.menu
    n = 1
    menumax(0) = 1
    FOR a = 1 TO menus
        IF a = 1 THEN shift = 0
        n = n + LEN(menu$(a, 0)) + 4
        menumax(a) = n
        LOCATE 1, menumax(a - 1) + 3: PRINT menu$(a, 0)
        LINE (menumax(a) * xtextsize, 0)-(menumax(a) * xtextsize, ytextsize)
    NEXT a
    maximum.menux = (menuwidth * xtextsize) + xtextsize * menumax(menus)
    LINE (0, ytextsize)-(maximum.menux, ytextsize)
END SUB

SUB drawscreen
    '========================draw.menus
    CLS
    draw.menu
END SUB

SUB handle.option (option$)
    SELECT CASE LCASE$(option$)
        CASE "clear the screen"
            close.a.menu
            showmouse
            CLS
            showmouse
            drawscreen
        CASE "exit"
            close.a.menu
            done = are.you.sure
        CASE "pick a colour"
            close.a.menu
            showmouse
            GET (0, 470)-(160, 479), background
            PUT (0, 470), background
            FOR n = 0 TO 15
                LINE (n * 10, 470)-((n + 1) * 10, 480), n, BF
                LINE (n * 10, 470)-((n + 1) * 10, 480), 15, B
            NEXT n
            showmouse
            DO
                x = mousex
                y = mousey
            LOOP UNTIL buttonpressed AND x < 161 AND y > 469
            colour = INT(x / 10)
            showmouse
            PUT (0, 470), background, PSET
            showmouse
        CASE "use pencil"
            close.a.menu
            drawmode = 1
        CASE "use eraser"
            close.a.menu
            drawmode = 0
    END SELECT
END SUB

SUB load.menus (filenum)
    FOR n = 1 TO menus
        INPUT #filenum, menu$(n, 0)
        INPUT #filenum, menulength(n)
        FOR a = 1 TO menulength(n)
            INPUT #filenum, menu$(n, a)
        NEXT a
    NEXT n
END SUB

FUNCTION mousex
    inregs.ax = 3: CALL interrupt(51, inregs, outregs)
    mousex = outregs.cx
END FUNCTION

FUNCTION mousey
    inregs.ax = 3: CALL interrupt(51, inregs, outregs)
    mousey = outregs.dx
END FUNCTION

FUNCTION on.a.menu
    q = 0
    IF mousex > minmenx AND mousex < maxmenx THEN
        IF mousey > minmeny AND mousey < maxmeny THEN
             q = 1
        END IF
    END IF
    on.a.menu = q
END FUNCTION

SUB open.a.menu (menu.index)
   
    '--------- determine width
    menuwidth = 0
    FOR n = 1 TO menulength(menu.index)
        cwidth = LEN(menu$(menu.index, n))
        IF cwidth > menuwidth THEN menuwidth = cwidth
    NEXT n
   
    '--------- get screen
    minmenx = xtextsize * menumax(menu.index - 1) - 4
    minmeny = ytextsize - 4
    maxmenx = (menuwidth * xtextsize) + xtextsize * menumax(menu.index - 1) + 4
    maxmeny = menulength(menu.index) * ytextsize + minmeny + 4
    GET (minmenx, minmeny)-(maxmenx, maxmeny), background
    PUT (minmenx, minmeny), background
    old.menu.index = menu.index
   
    '--------- print text
    FOR n = 1 TO menulength(menu.index)
        LOCATE 1 + n, menumax(menu.index - 1) + 1
        PRINT menu$(menu.index, n)
    NEXT n
   
    '--------- draw edge of menu
    LINE (minmenx, minmeny)-(maxmenx, maxmeny), , B
    LINE (minmenx + 2, minmeny + 2)-(maxmenx - 2, maxmeny - 2), , B
    LINE (minmenx + 1, minmeny + 1)-(minmenx + 1, maxmeny - 1)
    LINE (minmenx + 1, minmeny + 1)-(maxmenx - 1, minmeny + 1)

END SUB

FUNCTION read.menu$
    y = mousey
    selection = 0
    FOR n = 1 TO menulength(old.menu.index)
        IF y >= n * ytextsize AND y < (n + 1) * ytextsize THEN
            selection = n
        END IF
    NEXT n
    read.menu$ = menu$(old.menu.index, selection)
END FUNCTION

SUB showmouse STATIC
    IF mouseon THEN
        inregs.ax = 2: CALL interrupt(51, inregs, outregs)
    ELSE
        inregs.ax = 1: CALL interrupt(51, inregs, outregs)
    END IF
    mouseon = 1 - mouseon
END SUB

