DECLARE FUNCTION choice% (filename$, icons%, text$)
DECLARE FUNCTION takevalue! (text$)
DEFINT A-Z

'=================================declarations
DECLARE FUNCTION get.page.name$ (n%)
DECLARE SUB handle.button ()
DECLARE SUB remove.a.page ()
DECLARE SUB add.a.page ()
DECLARE FUNCTION iclname$ ()
DECLARE SUB turn.page ()
DECLARE FUNCTION number.of.pages% ()
DECLARE SUB remove.an.icon ()
DECLARE SUB alter.icon.properties ()
DECLARE SUB handle.icon (a$)
DECLARE SUB add.an.icon ()
DECLARE SUB drag.icon ()
DECLARE SUB draw.icons ()
DECLARE SUB check.for.icons ()
DECLARE SUB assign.icon.numbers ()
DECLARE SUB draw.icon (n%, c%)
DECLARE SUB handle.option (option$)
DECLARE SUB close.a.menu ()
DECLARE SUB drawscreen ()
DECLARE SUB load.menus (filenum%)
DECLARE SUB open.a.menu (menu.index%)
DECLARE SUB showmouse ()
DECLARE FUNCTION icons.touching% (n%, m%)
DECLARE FUNCTION takenum% (text$)
DECLARE FUNCTION taketext$ (text$)
DECLARE FUNCTION array.size% (x1%, y1%, x2%, y2%)
DECLARE FUNCTION double.click% ()
DECLARE FUNCTION current.icon% ()
DECLARE FUNCTION buttonpressed% ()
DECLARE FUNCTION current.menu% ()
DECLARE FUNCTION mousex% ()
DECLARE FUNCTION mousey% ()
DECLARE FUNCTION okay% (a$)
DECLARE FUNCTION on.a.menu% ()
DECLARE FUNCTION read.menu$ ()
'=================================interrupts
'ON ERROR GOTO errhandle
ON KEY(10) GOSUB breakprog: KEY(10) ON
'=================================variables
CONST click.speed = .2
CONST xtextsize = 8
CONST ytextsize = 16
CONST xscreensize = 639
CONST yscreensize = 479
TYPE icontype
	x AS INTEGER
	y AS INTEGER
	xsize AS INTEGER
	ysize AS INTEGER
END TYPE
TYPE regtype
	ax AS INTEGER: bx AS INTEGER
	cx AS INTEGER: dx AS INTEGER
	bp AS INTEGER: si AS INTEGER
	di AS INTEGER: flags AS INTEGER
	ds AS INTEGER: es AS INTEGER
END TYPE
DIM SHARED icons
DIM SHARED icons.changed, menus.changed
icons = 0
DIM SHARED inregs AS regtype, outregs AS regtype, menus, background(15000)
DIM SHARED old.menu.index, minmenx, minmeny, maxmenx, maxmeny, done
DIM SHARED rusure(5000), menu.open, oldmousex, oldmousey, maximum.menux
DIM SHARED icon(icons) AS icontype, iconname$(icons), icondata$(icons)
DIM SHARED progname$(icons), progpath$(icons), button(2633)
DIM SHARED picture2(2633), picture(2633)
DIM SHARED current.page, numpages, pagename$
'=========================Misc.
'------------initialize mouse
inregs.ax = 0: CALL interrupt(51, inregs, outregs)
inregs.ax = 4: CALL interrupt(51, inregs, outregs)
inregs.ax = 3: CALL interrupt(51, inregs, outregs)

'------------load page
numpages = number.of.pages
OPEN "cpg.~~" FOR INPUT AS #1
INPUT #1, current.page
CLOSE #1
pagename$ = get.page.name$(current.page)

'------------load menus
OPEN "gui.mnu" FOR INPUT AS #1
INPUT #1, menus
DIM SHARED menu$(menus, 20), menumax(menus), menulength(menus)
load.menus (1)
CLOSE #1

'------------load icons
icons = 1
'check.for.icons
REDIM SHARED icon(icons) AS icontype, iconname$(icons), icondata$(icons)
REDIM SHARED progname$(icons), progpath$(icons)
assign.icon.numbers

'------------set up screen
SCREEN 12: CLS
PALETTE 0, 63 + 63 * 256 + 63 * 65536
PALETTE 15, 0
drawscreen
draw.icons
showmouse
'===============================main program==================================
DO
	ico = current.icon
	IF double.click AND ico <> 0 THEN
		handle.icon (icondata$(ico))
		ico = 0
	END IF
	IF menus.changed = 1 THEN
		pagename$ = get.page.name$(current.page)
		p = FREEFILE
		OPEN "gui.mnu" FOR INPUT AS #p
		INPUT #p, menus
		REDIM SHARED menu$(menus, 20), menumax(menus), menulength(menus)
		load.menus (1)
		CLOSE #p
		menus.changed = 0
	END IF
	IF icons.changed = 1 THEN
		 icons.changed = 0
		'check.for.icons
		REDIM SHARED icon(icons) AS icontype, iconname$(icons), icondata$(icons)
		REDIM SHARED progname$(icons), progpath$(icons)
		assign.icon.numbers
		showmouse
		drawscreen
		draw.icons
		showmouse
	END IF
	'======================== left button pressed
	bp = buttonpressed
	IF bp THEN
		IF mousey <= 15 AND mousex <= maximum.menux THEN
			oldx = -1
			oldy = -1
			'------- left button on the upper menus
			IF menu.open <> 0 THEN
				close.a.menu
			END IF
			IF menu.open <> current.menu THEN
				menu.open = current.menu
				showmouse
				open.a.menu (current.menu)
				showmouse
			END IF
			DO: LOOP UNTIL buttonpressed = 0
		ELSEIF on.a.menu AND menu.open <> 0 THEN
			handle.option (read.menu$)'----read.menu$ is a function
		ELSE
			'------- button pressed off the menus
			IF menu.open <> 0 THEN
				close.a.menu
				DO: LOOP UNTIL buttonpressed = 0
			ELSE ' (all menus are closed)
				boolean = 0

				IF oldx <> -1 AND current.icon = 0 THEN
					'====draw here
					IF bp = 1 THEN
					ELSEIF bp = 2 THEN
					END IF
					boolean = 1
				END IF

				IF current.icon <> 0 THEN
					IF mousey > ytextsize THEN
						IF bp = 2 THEN
							drag.icon
						END IF
						boolean = 1
					ELSE
						handle.button
					END IF
				END IF

				IF NOT boolean THEN
					oldx = mousex
					oldy = mousey
				END IF
			END IF
		END IF
	ELSE
		oldx = -1
	END IF
LOOP UNTIL done
CLOSE
OPEN "cpg.~~" FOR OUTPUT AS #1
PRINT #1, current.page
CLOSE #1
SYSTEM
'===============================subroutines===================================

'errhandle:
'    STOP
'    RESUME NEXT

breakprog:

SUB add.a.page
	name$ = taketext$("What title do you wish to give this page?")
	f = FREEFILE
	OPEN "junk" FOR OUTPUT AS #f
	PRINT #f, "yes.pic"
	PRINT #f, "no.pic"
	CLOSE #f
	IF choice("junk", 2, "Are you sure?") THEN
		f = FREEFILE
		numpages = numpages + 1
		current.page = numpages
	  
		'-------- add the page to the book
		OPEN "book.dat" FOR APPEND AS #f
			PRINT #f, name$
		CLOSE #f

		'-------- make the page's menu
		a$ = iclname$
		OPEN a$ FOR OUTPUT AS #f
			PRINT #f, "flipl.ico"
			PRINT #f, "flipr.ico"
		CLOSE #f
	   
		menus.changed = 1
		icons.changed = 1
	END IF
END SUB

SUB add.an.icon
	DO
		'================= select an icon
		fileexists = 0
		a$ = taketext$("What icon do you wish to load?")
		IF a$ = "" THEN
			fini = 1
		ELSE
			'================= test to see if the icon exists
			s$ = "dir/b/one " + a$ + " > test.dat"
			SHELL s$
			f = FREEFILE
			OPEN "test.dat" FOR INPUT AS #f
			WHILE NOT EOF(f)
				INPUT #f, s$
				IF LCASE$(s$) = LCASE$(a$) THEN fileexists = 1
			WEND
			CLOSE #f
			IF fileexists = 1 THEN
			  
				'============= add name and path to file data
				f = FREEFILE
				OPEN a$ FOR APPEND AS #f
			 
				q$ = taketext$("What is the name of the program this icon starts?")
				PRINT #f, q$
				q$ = taketext$("What is the search path for this program?")
				PRINT #f, q$
				CLOSE #f

				'========= add to icon list"
				fini = 1
				f = FREEFILE
				OPEN iclname$ FOR APPEND AS #f
				PRINT #f, a$
				CLOSE #f
				icons.changed = 1
		  
			END IF
		END IF
	LOOP UNTIL fini = 1
END SUB

SUB alter.icon.properties
	DO
		'================= select an icon
		fileexists = 0
		a$ = taketext$("What icon do you wish to change?")
		IF a$ = "" THEN
			fini = 1
		ELSE
			'================= test to see if the icon exists
			s$ = "dir/b/one " + a$ + " > test.dat"
			SHELL s$
			f = FREEFILE
			OPEN "test.dat" FOR INPUT AS #f
			WHILE NOT EOF(f)
				INPUT #f, s$
				IF LCASE$(s$) = LCASE$(a$) THEN fileexists = 1
			WEND
			CLOSE #f
			IF fileexists = 1 THEN
				'=================== get size and picture name
				OPEN a$ FOR INPUT AS #f
				INPUT #f, B$
				INPUT #f, bx
				INPUT #f, by
				INPUT #f, bxsize
				INPUT #f, bysize
				CLOSE #f

				'=================== rewrite with new data
				OPEN a$ FOR OUTPUT AS #f
				PRINT #f, B$
				PRINT #f, bx
				PRINT #f, by
				PRINT #f, bxsize
				PRINT #f, bysize
				q$ = taketext$("What is the name of the program this icon starts?")
				PRINT #f, q$
				q$ = taketext$("What is the search path for this program?")
				PRINT #f, q$
			   
				CLOSE #f
				fini = 1
			END IF
		END IF
	LOOP UNTIL fini = 1
END SUB

SUB assign.icon.numbers
	OPEN iclname$ FOR INPUT AS #1
	FOR n = 1 TO icons
		DO
			LINE INPUT #1, iconname$(n)
		LOOP UNTIL iconname$(n) <> ""
		IF iconname$(n) <> "" THEN
			icondata$(n) = iconname$(n)
			OPEN icondata$(n) FOR INPUT AS #2
			INPUT #2, iconname$(n)
			INPUT #2, icon(n).x
			INPUT #2, icon(n).y
			INPUT #2, icon(n).xsize
			INPUT #2, icon(n).ysize
			IF NOT EOF(2) THEN INPUT #2, progname$(n)
			IF NOT EOF(2) THEN INPUT #2, progpath$(n)
			CLOSE #2
		END IF
	NEXT n
	CLOSE #1
END SUB

FUNCTION buttonpressed%
	inregs.ax = 3: CALL interrupt(51, inregs, outregs)
	buttonpressed = outregs.bx
END FUNCTION

FUNCTION choice (filename$, icons, text$)
	'==================================set values, draw window
	DIM file$(icons), buttonxsize(icons), buttonysize(icons)
	DIM buttonx(icons), buttony(icons)
	'----- load the icon data
	f = FREEFILE
	OPEN filename$ FOR INPUT AS #f
	n = 0
	DEF SEG = VARSEG(button(0))
	FOR n = 1 TO icons
		INPUT #f, file$(n)
		BLOAD file$(n), VARPTR(button(0))
		buttonxsize(n) = button(0)
		buttonysize(n) = button(1)
	NEXT n
	CLOSE #f

	'---- determine the necessary size of the window
	'--x
	tlen = LEN(text$)
	textx = 40 - INT(tlen / 2)
	FOR n = 1 TO icons
		xminsize = xminsize + buttonxsize(n) + 10
	NEXT n
	IF xminsize < (tlen + 6) * xtextsize THEN xminsize = (tlen + 6) * xtextsize

	'--y
	FOR n = 1 TO icons
		IF yminsize < buttonysize(n) THEN yminsize = buttonysize(n)
	NEXT n
	yminsize = yminsize + 40

	x1 = 320 - (xminsize / 2)
	y1 = 240 - (yminsize / 2)
	x2 = 320 + (xminsize / 2)
	y2 = 240 + (yminsize / 2)
	texty = INT(y1 / ytextsize) + 2

	showmouse

	'------- get background and print text
	GET (x1, y1)-(x2, y2), background
	PUT (x1, y1), background
	LOCATE texty, textx: PRINT text$;

	'------- draw box borders of the window
	LINE (x1, y1)-(x2, y2), , B
	LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
	LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
	LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)

	'------- determine the icon positions

	'-- x
	a = xminsize
	FOR n = 1 TO icons
		a = a - buttonxsize(n)
	NEXT n
	a = a / (icons + 1)
	icx = 320 - (xminsize / 2)
	FOR n = 1 TO icons
		icx = icx + a
		buttonx(n) = icx
		icx = icx + buttonxsize(n)
	NEXT n

	'-- y
	a = y2 - (y1 + 2 * ytextsize)
	a = y2 - a / 2
	FOR n = 1 TO icons
		buttony(n) = a - buttonysize(n) / 2
	NEXT n
						
	'----- load and draw the icons
	FOR n = 1 TO icons
		DEF SEG = VARSEG(button(0))
		BLOAD file$(n), VARPTR(button(0))
		PUT (buttonx(n), buttony(n)), button
	NEXT n
	DEF SEG

	showmouse
	'========== handle i/o
	DO
		x = mousex
		y = mousey
		IF buttonpressed = 1 THEN
			FOR n = 1 TO icons
				IF x >= buttonx(n) AND x <= buttonx(n) + buttonxsize(n) THEN
					IF y >= buttony(n) AND y <= buttony(n) + buttonysize(n) THEN
						choice = n
						gotone = n
					END IF
				END IF
			NEXT n
		END IF
	LOOP UNTIL gotone <> 0
	'======= redraw screen
	showmouse
	PUT (x1, y1), background, PSET
	showmouse
END FUNCTION

SUB close.a.menu '(menu.index)
	showmouse
	'PUT (xtextsize * menumax(old.menu.index - 1), ytextsize), background, PSET
	PUT (minmenx, minmeny), background, PSET
	showmouse
	menu.open = 0
END SUB

FUNCTION current.icon
	x = mousex
	y = mousey
	c.i = 0
	FOR n = 1 TO icons
		a = x - icon(n).x
		B = y - icon(n).y
		IF a >= 0 AND a <= icon(n).xsize THEN
			IF B >= 0 AND B <= icon(n).ysize THEN
				c.i = n
			END IF
		END IF
	NEXT n
	current.icon = c.i
END FUNCTION

FUNCTION current.menu
	FOR n = 1 TO menus
		IF mousex < menumax(n) * xtextsize THEN EXIT FOR
	NEXT n
	IF n > menus THEN n = menus
	current.menu = n
END FUNCTION

FUNCTION double.click STATIC
	lastclick = B
	B = buttonpressed
	SELECT CASE B
		CASE 0
			IF TIMER - t! < click.speed THEN got.a.0 = 1
		CASE ELSE
			IF TIMER - t! < click.speed AND got.a.0 = 1 THEN double.click = B
			t! = TIMER
			got.a.0 = 0
	END SELECT
END FUNCTION

SUB drag.icon
	n = current.icon
	x = mousex
	y = mousey
   
	x1 = icon(n).x
	y1 = icon(n).y
	x2 = icon(n).x + icon(n).xsize
	y2 = icon(n).y + icon(n).ysize
	xoffset = x - x1
	yoffset = y - y1
	showmouse
	draw.icon n, 0
	PUT (x1, y1), picture
	showmouse
	doneonce = 0
	DO
		IF (oldmousex <> mousex OR oldmousey <> mousey) AND doneonce = 1 THEN
			x = mousex
			y = mousey
			oldmousex = x
			oldmousey = y
			x1 = x - xoffset
			y1 = y - yoffset
		   
			'=========account for walls
			IF x1 > xscreensize - icon(n).xsize THEN
				x1 = xscreensize - icon(n).xsize
				x2 = xscreensize
				xoffset = x - x1
			END IF
			IF y1 > yscreensize - icon(n).ysize THEN
				y1 = yscreensize - icon(n).ysize
				y2 = yscreensize
				yoffset = y - y1
			END IF
			IF x1 < 0 THEN
				x1 = 0
				x2 = icon(n).xsize
				xoffset = x - x1
			END IF
			IF y1 < 0 THEN
				y1 = 0
				y2 = icon(n).ysize
				yoffset = y - y1
			END IF
			IF y1 < ytextsize + 2 THEN
				y1 = ytextsize + 2
				y2 = y1 + icon(n).ysize
				yoffset = y - y1
			END IF
			'=============draw the icon if moving
			showmouse
			PUT (oldx, oldy), picture2, PSET
			GET (x1, y1)-(x1 + icon(n).xsize, y1 + icon(n).ysize), picture2
			icon(n).x = x1
			icon(n).y = y1
			draw.icon n, 2
			showmouse
		ELSEIF doneonce = 0 THEN
			doneonce = 1
			showmouse
			FOR m = 1 TO icons
				IF n <> m THEN
					IF icons.touching(n, m) THEN draw.icon m, 1
				END IF
			NEXT m
			draw.icon n, 0
			GET (x1, y1)-(x1 + icon(n).xsize, y1 + icon(n).ysize), picture2
			showmouse
			icon(n).x = x1
			icon(n).y = y1
		END IF
		oldx = x1
		oldy = y1
   
	LOOP UNTIL buttonpressed = 0
	showmouse
	draw.icon n, 1
	showmouse
	f = FREEFILE
	OPEN icondata$(n) FOR OUTPUT AS #f
	PRINT #f, iconname$(n)
	PRINT #f, icon(n).x
	PRINT #f, icon(n).y
	PRINT #f, icon(n).xsize
	PRINT #f, icon(n).ysize
	PRINT #f, progname$(n)
	PRINT #f, progpath$(n)
	CLOSE #f

END SUB

SUB draw.icon (n, c)
	SELECT CASE c
		CASE 0    '-----loads
			DEF SEG = VARSEG(picture(0))
			BLOAD iconname$(n), VARPTR(picture(0))
			DEF SEG
	   
		CASE 1 '----- loads and draws
			DEF SEG = VARSEG(picture(0))
			BLOAD iconname$(n), VARPTR(picture(0))
			DEF SEG
			a = icon(n).x
			B = icon(n).y
			c = icon(n).x + icon(n).xsize
			d = icon(n).y + icon(n).ysize
			PUT (a, B), picture, PSET

		CASE 2 '------ draws
			a = icon(n).x
			B = icon(n).y
			c = icon(n).x + icon(n).xsize
			d = icon(n).y + icon(n).ysize
			PUT (a, B), picture, PSET
	END SELECT
END SUB

SUB draw.icons
	FOR n = 1 TO icons
		DEF SEG = VARSEG(picture(0))
		BLOAD iconname$(n), VARPTR(picture(0))
		PUT (icon(n).x, icon(n).y), picture, PSET
	NEXT n
	DEF SEG
END SUB

SUB drawscreen
	'========================draw.menus
	CLS
	n = 1
	menumax(0) = 1
	FOR a = 1 TO menus
		IF a = 1 THEN shift = 0
		n = n + LEN(menu$(a, 0)) + 4
		menumax(a) = n
		LOCATE 1, menumax(a - 1) + 3: PRINT menu$(a, 0)
		LINE (menumax(a) * xtextsize, 0)-(menumax(a) * xtextsize, ytextsize)
	NEXT a
	'--draw page title
	LOCATE 1, 58 - INT(LEN(pagename$)): PRINT pagename$
	maximum.menux = (menuwidth * xtextsize) + xtextsize * menumax(menus)
	LINE (0, ytextsize)-(639, ytextsize)
	LINE (0, ytextsize - 2)-(maximum.menux, ytextsize - 2)
END SUB

FUNCTION get.page.name$ (n)
	a = FREEFILE
	OPEN "book.dat" FOR INPUT AS #a
	FOR m = 1 TO n - 1
		DO
			LINE INPUT #a, junk$
		LOOP UNTIL junk$ <> ""
	NEXT m
	LINE INPUT #a, a$
	CLOSE #a
	get.page.name$ = a$
END FUNCTION

SUB handle.button
	SELECT CASE current.icon
		CASE 1
			IF current.page > 1 THEN
				current.page = current.page - 1
				menus.changed = 1
				icons.changed = 1
			END IF
		CASE 2
			IF current.page < numpages THEN
				current.page = current.page + 1
				menus.changed = 1
				icons.changed = 1
			END IF
	END SELECT
END SUB

SUB handle.icon (a$)
	n = FREEFILE
	OPEN a$ FOR INPUT AS #n
	INPUT #n, a$
	INPUT #n, junk
	INPUT #n, junk
	INPUT #n, junk
	INPUT #n, junk
	IF NOT EOF(n) THEN
		done = 1
		'-------- get the current search path
		SHELL "path > junk"
		m = FREEFILE
		OPEN "junk" FOR INPUT AS #m
		INPUT #m, oldpath$
		CLOSE #m
	 
		'-------- get the current working directory
		SHELL "CD > junk"
		m = FREEFILE
		OPEN "junk" FOR INPUT AS #m
		INPUT #m, olddirectory$
		CLOSE #m
	  
		DO: INPUT #n, progname$: LOOP UNTIL progname$ <> ""
		DO: INPUT #n, path$: LOOP UNTIL path$ <> ""
	  
		'------- write execute.bat
		OPEN "execute.bat" FOR OUTPUT AS #m
		PRINT #m, "@ECHO OFF"
		PRINT #m, "path " + path$
		PRINT #m, "CD " + path$
		PRINT #m, progname$
		PRINT #m, oldpath$
		PRINT #m, "CD " + olddirectory$
		PRINT #m, "GUI.BAT"
		CLOSE #m
	END IF
	CLOSE #n
END SUB

SUB handle.option (option$)
	SELECT CASE LCASE$(option$)
		CASE "exit"
			close.a.menu
			f = FREEFILE
			OPEN "junk" FOR OUTPUT AS #f
			PRINT #f, "yes.pic"
			PRINT #f, "no.pic"
			CLOSE #f
			IF choice("junk", 2, "Are you sure you want to exit?") THEN
				done = 1
				n = FREEFILE
				OPEN "execute.bat" FOR OUTPUT AS #n
				PRINT #n, "@echo off"
				PRINT #n, "cls"
				PRINT #n, "echo Remember to Register!"
			END IF
		CASE "add an icon"
			close.a.menu
			add.an.icon
		CASE "alter an icon's properties"
			close.a.menu
			alter.icon.properties
		CASE "remove an icon"
			close.a.menu
			remove.an.icon
		CASE "add a page"
			close.a.menu
			add.a.page
		CASE "turn to page..."
			close.a.menu
			turn.page
		CASE "remove a page"
			close.a.menu
			remove.a.page
	END SELECT
END SUB

FUNCTION iclname$
	number$ = RIGHT$(STR$(current.page), LEN(STR$(current.page)) - 1)
	iclname$ = "pg" + number$ + ".icl"
END FUNCTION

FUNCTION icons.touching (n, m)
	a = icon(m).x
	B = icon(m).y
	c = a + icon(m).xsize
	d = B + icon(m).ysize
   
	x1 = icon(n).x
	y1 = icon(n).y
	x2 = x1 + icon(n).xsize
	y2 = y1 + icon(n).ysize

	c1 = (a >= x1 AND a <= x2)
	c2 = (c >= x1 AND c <= x2)
	c3 = (B >= y1 AND B <= y2)
	c4 = (d >= y1 AND d <= y2)
	c5 = (a <= x1 AND c >= x2)
	c6 = (B <= y1 AND d >= y2)
   
	IF (c1 OR c2 OR c5) AND (c3 OR c4 OR c6) THEN icons.touching = 1
END FUNCTION

SUB load.menus (filenum)
	FOR n = 1 TO menus
		INPUT #filenum, menu$(n, 0)
		INPUT #filenum, menulength(n)
		FOR a = 1 TO menulength(n)
			INPUT #filenum, menu$(n, a)
		NEXT a
	NEXT n
END SUB

FUNCTION mousex
	inregs.ax = 3: CALL interrupt(51, inregs, outregs)
	mousex = outregs.cx
END FUNCTION

FUNCTION mousey
	inregs.ax = 3: CALL interrupt(51, inregs, outregs)
	mousey = outregs.dx
END FUNCTION

FUNCTION number.of.pages
	n = FREEFILE
	OPEN "book.dat" FOR INPUT AS #n
		DO
			LINE INPUT #n, junk$
			IF junk$ <> "" THEN a = a + 1
		LOOP UNTIL EOF(n)
	CLOSE #n
	number.of.pages = a
END FUNCTION

FUNCTION on.a.menu
	q = 0
	IF mousex > minmenx AND mousex < maxmenx THEN
		IF mousey > minmeny AND mousey < maxmeny THEN
			 q = 1
		END IF
	END IF
	on.a.menu = q
END FUNCTION

SUB open.a.menu (menu.index)
   
	'--------- determine width
	menuwidth = 0
	FOR n = 1 TO menulength(menu.index)
		cwidth = LEN(menu$(menu.index, n))
		IF cwidth > menuwidth THEN menuwidth = cwidth
	NEXT n
   
	'--------- get screen
	minmenx = xtextsize * menumax(menu.index - 1) - 4
	minmeny = ytextsize - 4
	maxmenx = (menuwidth * xtextsize) + xtextsize * menumax(menu.index - 1) + 4
	maxmeny = menulength(menu.index) * ytextsize + minmeny + 4
	GET (minmenx, minmeny)-(maxmenx, maxmeny), background
	PUT (minmenx, minmeny), background
	old.menu.index = menu.index
   
	'--------- print text
	FOR n = 1 TO menulength(menu.index)
		LOCATE 1 + n, menumax(menu.index - 1) + 1
		PRINT menu$(menu.index, n)
	NEXT n
   
	'--------- draw edge of menu
	LINE (minmenx, minmeny)-(maxmenx, maxmeny), , B
	LINE (minmenx + 2, minmeny + 2)-(maxmenx - 2, maxmeny - 2), , B
	LINE (minmenx + 1, minmeny + 1)-(minmenx + 1, maxmeny - 1)
	LINE (minmenx + 1, minmeny + 1)-(maxmenx - 1, minmeny + 1)

END SUB

FUNCTION read.menu$
	y = mousey
	selection = 0
	FOR n = 1 TO menulength(old.menu.index)
		IF y >= n * ytextsize AND y < (n + 1) * ytextsize THEN
			selection = n
		END IF
	NEXT n
	read.menu$ = menu$(old.menu.index, selection)
END FUNCTION

SUB remove.a.page
	DO
		n = takevalue("What page do you wish to remove?")
	LOOP UNTIL n > 1 AND n <= numpages
	f = FREEFILE
	OPEN "junk" FOR OUTPUT AS #f
	PRINT #f, "yes.pic"
	PRINT #f, "no.pic"
	CLOSE #f
	IF choice("junk", 2, "Are you sure?") THEN
	   
		f = FREEFILE
		numpages = numpages - 1
	   
		'-------- remove the page from the book
		OPEN "book.dat" FOR INPUT AS #f
		g = FREEFILE: OPEN "junk" FOR OUTPUT AS #g
		DO
			a = a + 1
			DO
				LINE INPUT #f, a$
			LOOP UNTIL a$ <> ""
			IF a <> n THEN PRINT #g, a$
		LOOP UNTIL EOF(1)
		CLOSE #g, #f
		KILL "book.dat"
		SHELL "rename junk book.dat"

		'-------- erase the page's menu and icon list
		a$ = iclname$
		KILL a$

		current.page = 1
		menus.changed = 1
		icons.changed = 1
	END IF
END SUB

SUB remove.an.icon
END SUB

SUB showmouse STATIC
	IF mouseon THEN
		inregs.ax = 2: CALL interrupt(51, inregs, outregs)
	ELSE
		inregs.ax = 1: CALL interrupt(51, inregs, outregs)
	END IF
	mouseon = 1 - mouseon
END SUB

FUNCTION taketext$ (text$)
	'==================================set values, draw window
	DO: LOOP UNTIL INKEY$ = ""
	textx = 40 - INT(LEN(text$) / 2)
	x1 = (textx - 3) * xtextsize
	y1 = 13 * ytextsize
	x2 = x1 + xtextsize * (LEN(text$) + 3)
	y2 = y1 + ytextsize * 6
	showmouse
	GET (x1, y1)-(x2, y2), background
	PUT (x1, y1), background
	LOCATE 15, textx: PRINT text$;
	LINE (x1, y1)-(x2, y2), , B
	LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
	LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
	LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)
	a = (textx - 1.5) * xtextsize - 2
	B = 15.5 * ytextsize
	c = a + (LEN(text$) + 1) * xtextsize
	d = B + 2 * ytextsize
	LINE (a, B)-(c, d), , B
	LINE (a + 2, B + 2)-(c - 2, d - 2), , B
	LINE (a + 1, B + 1)-(a + 1, d - 1)
	LINE (a + 1, B + 1)-(c - 1, B + 1)
	'=================================== Handle I/O
	maxlength = LEN(text$) - 1
	text$ = ""
	LOCATE 17, textx
	showmouse
	DO
		DO: a$ = INKEY$: LOOP UNTIL a$ <> "" OR doneonce = 0
		IF doneonce = 0 THEN
			doneonce = 1
			write.the.text = 1
		END IF
		IF a$ <> "" THEN
			n = ASC(LEFT$(a$, 1))
		ELSE
			n = 1000
		END IF
		SELECT CASE n
			CASE 0
				m$ = RIGHT$(a$, 1)
				SELECT CASE m$
					CASE "K"'--left
						IF LEN(text$) + offset > 0 THEN offset = offset - 1
					CASE "M"'--right
						IF offset < 0 THEN offset = offset + 1
					CASE CHR$(83)'--(Delete)
						IF offset < 0 THEN
							n = LEN(text$) + offset
							text$ = LEFT$(text$, n) + RIGHT$(text$, ABS(offset + 1))
							offset = offset + 1
							write.the.text = 1
							erase.last.character = 1
						END IF
					CASE CHR$(82)'--(insert)
						insert = 1 - insert
				END SELECT
			CASE 8 '--(bspace)
				 IF LEN(text$) > ABS(offset) THEN
					IF offset = 0 THEN
						text$ = LEFT$(text$, LEN(text$) - 1)
					ELSE
						n = LEN(text$) + offset
						text$ = LEFT$(text$, n - 1) + RIGHT$(text$, ABS(offset))
					END IF
					erase.last.character = 1
					write.the.text = 1
				END IF
			CASE 27
				cancel = 1
			CASE 13
				ready = 1
			CASE IS > 31
				IF n < 127 THEN
					IF offset = 0 THEN
						text$ = text$ + a$
						write.the.text = 1
					ELSE
						n = LEN(text$) + offset
						IF insert THEN
							B$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset))
						ELSE
							B$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset) - 1)
							offset = offset + 1
						END IF
						text$ = B$
						write.the.text = 1
					END IF
				END IF
		END SELECT
		showmouse
		LINE (a, B)-(c, d), 0, B
		IF LEN(text$) > maxlength THEN shift = shift + 1
		IF write.the.text OR erase.last.character THEN
			IF erase.last.character THEN
				erase.last.character = 0
				LOCATE 17, textx + LEN(text$)
				PRINT " ";
			END IF
			write.the.text = 0
			LOCATE 17, textx
	   
			IF LEN(text$) <= maxlength THEN
				display.text$ = text$
			ELSE
				display.text$ = MID$(text$, offset + 1, maxlength)
			END IF
			PRINT display.text$
		END IF
		cursormode = insert
		a = xtextsize * (textx + LEN(text$) + offset - 1) - 1
		B = ytextsize * 16
		c = xtextsize * (textx + LEN(text$) + offset) - 1
		d = ytextsize * 17
		IF cursormode = 1 THEN
			LINE (a, B)-(a, d)
		ELSE
			LINE (a, B)-(c, d), , B
		END IF
		showmouse
	LOOP UNTIL ready OR cancel
	IF ready THEN taketext$ = text$
	PUT (x1, y1), background, PSET
'==============
END FUNCTION

FUNCTION takevalue! (text$)
	'==================================set values, draw window
	textx = 40 - INT(LEN(text$) / 2)
	x1 = (textx - 3) * xtextsize
	y1 = 13 * ytextsize
	x2 = x1 + xtextsize * (LEN(text$) + 3)
	y2 = y1 + ytextsize * 6
	showmouse
	GET (x1, y1)-(x2, y2), background
	PUT (x1, y1), background
	LOCATE 15, textx: PRINT text$;
	LINE (x1, y1)-(x2, y2), , B
	LINE (x1 + 2, y1 + 2)-(x2 - 2, y2 - 2), , B
	LINE (x1 + 1, y2 - 1)-(x2 - 1, y2 - 1)
	LINE (x2 - 1, y1 + 1)-(x2 - 1, y2 - 1)
	a = (textx - 1.5) * xtextsize - 2
	B = 15.5 * ytextsize
	c = a + (LEN(text$) + 1) * xtextsize
	d = B + 2 * ytextsize
	LINE (a, B)-(c, d), , B
	LINE (a + 2, B + 2)-(c - 2, d - 2), , B
	LINE (a + 1, B + 1)-(a + 1, d - 1)
	LINE (a + 1, B + 1)-(c - 1, B + 1)
	'=================================== Handle I/O
	maxlength = LEN(text$) - 1
	text$ = ""
	LOCATE 17, textx
	showmouse
	DO
		DO: a$ = INKEY$: LOOP UNTIL a$ <> "" OR doneonce = 0
		IF doneonce = 0 THEN
			doneonce = 1
			write.the.text = 1
		END IF
		IF a$ <> "" THEN
			n = ASC(LEFT$(a$, 1))
		ELSE
			n = 1000
		END IF
		SELECT CASE n
			CASE 0
				m$ = RIGHT$(a$, 1)
				SELECT CASE m$
					CASE "K"'--left
						IF LEN(text$) + offset > 0 THEN offset = offset - 1
					CASE "M"'--right
						IF offset < 0 THEN offset = offset + 1
					CASE CHR$(83)'--(Delete)
						IF offset < 0 THEN
							n = LEN(text$) + offset
							text$ = LEFT$(text$, n) + RIGHT$(text$, ABS(offset + 1))
							offset = offset + 1
							write.the.text = 1
							erase.last.character = 1
						END IF
					CASE CHR$(82)'--(insert)
						insert = 1 - insert
				END SELECT
			CASE 8 '--(bspace)
				 IF LEN(text$) > ABS(offset) THEN
					IF offset = 0 THEN
						text$ = LEFT$(text$, LEN(text$) - 1)
					ELSE
						n = LEN(text$) + offset
						text$ = LEFT$(text$, n - 1) + RIGHT$(text$, ABS(offset))
					END IF
					erase.last.character = 1
					write.the.text = 1
				END IF
			CASE 27
				cancel = 1
			CASE 13
				ready = 1
			CASE ELSE
				IF ((n = 45) OR (n = 46) OR ((n < 58) AND (n > 47))) AND LEN(text$) < maxlength THEN '--(text)
					IF offset = 0 THEN
						text$ = text$ + a$
						write.the.text = 1
					ELSE
						n = LEN(text$) + offset
						IF insert THEN
							B$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset))
						ELSE
							B$ = LEFT$(text$, n) + a$ + RIGHT$(text$, ABS(offset) - 1)
							offset = offset + 1
						END IF
						text$ = B$
						write.the.text = 1
					END IF
				END IF
		END SELECT
		LINE (a, B)-(c, d), 0, B
		IF LEN(text$) > maxlength THEN shift = shift + 1
		IF write.the.text OR erase.last.character THEN
			IF erase.last.character THEN
				erase.last.character = 0
				LOCATE 17, textx + LEN(text$)
				PRINT " ";
			END IF
			write.the.text = 0
			LOCATE 17, textx
			showmouse
			IF LEN(text$) <= maxlength THEN
				display.text$ = text$
			ELSE
				display.text$ = MID$(text$, shift, maxlength)
			END IF
			PRINT display.text$

			'IF LEN(text$) <= maxlength THEN
			'    PRINT text$;
			'ELSE
			'    PRINT LEFT$(text$, maxlength);
			'END IF
			showmouse
		END IF
		cursormode = insert
		a = xtextsize * (textx + LEN(text$) + offset - 1) - 1
		B = ytextsize * 16
		c = xtextsize * (textx + LEN(text$) + offset) - 1
		d = ytextsize * 17
		IF cursormode = 1 THEN
			LINE (a, B)-(a, d)
		ELSE
			LINE (a, B)-(c, d), , B
		END IF
	LOOP UNTIL ready OR cancel
	IF ready THEN takevalue! = VAL(text$)
	PUT (x1, y1), background, PSET
'==============
END FUNCTION

SUB turn.page
	DO
		current.page = takevalue("What page do you want to turn to?")
	LOOP UNTIL current.page > 0 AND current.page <= numpages
	menus.changed = 1
	icons.changed = 1
END SUB

